const AsyncHook = require('./async-hook.js');

// If a another copy (same version or not) of stack-chain exists it will result
// in wrong stack traces (most likely dublicate callSites).
if (window._asyncHook) {
  // In case the version match, we can simply return the first initialized copy
  if (window._asyncHook.version === require('./package.json').version) {
    module.exports = window._asyncHook;
  }
  // The version don't match, this is really bad. Lets just throw
  else {
    throw new Error('Conflicting version of async-hook found');
  }
} else {
  module.exports = window._asyncHook = new AsyncHook();
}
